<?php
/**
 * ------------------------------------------------------------------------
 * JA Amazon S3 for Joomla 2.5 & Joomla 3.4
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2017 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * ------------------------------------------------------------------------
 */


// no direct access
defined ( '_JEXEC' ) or die ( 'Restricted access' );

defined('JPATH_BASE') or die();

jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.archive');
jimport('joomla.filesystem.path');

class jaAmazonS3ControllerAccount extends jaAmazonS3Controller {

	function __construct($default = array()) {

		parent::__construct ( $default );
		$jinput = JFactory::getApplication()->input;
		
		$task = $jinput->get( 'task', '' );
		switch ($task) {
			case 'add' :
			case 'save' :
			case 'apply' :
			case 'edit' :
				JToolBarHelper::apply ();
				JToolBarHelper::save ();
				JToolBarHelper::cancel ();
				break;
			default :
			    // Add a popup configuration button
				JToolBarHelper::addNew();
				JToolBarHelper::deleteList();
			    JToolBarHelper::preferences(JACOMPONENT, 250, 570);
				break;
		}
		// Register Extra tasks
		$jinput->set ( 'view', 'account' );
		$this->registerTask ( 'add', 'edit' );
		$this->registerTask ( 'apply', 'save' );
		$this->registerTask ( 'publish', 'setDefault' );
	}

	function display($cachable = false, $urlparams = false) {
		$jinput = JFactory::getApplication()->input;
		$user = JFactory::getUser ();
		$task =$this->getTask();
		switch ($task){
			case 'edit':
				$jinput->set( 'layout', 'form' );
				break;
			case 'config':
				$jinput->set( 'layout', 'config' );
				break;
		}
		if ($user->id == 0) {
			JFactory::getApplication()->enqueueMessage(JText::_("YOU_MUST_BE_SIGNED_IN" ), 'Warning');

			$this->setRedirect ( JRoute::_ ( "index.php?option=com_user&view=login" ) );

			return;
		}

		parent::display();
	}

	function cancel() {
		$this->setRedirect ( 'index.php?option='.JACOMPONENT.'&view=account' );

		return TRUE;
	}
	function save(&$errors = '') {
		$jinput = JFactory::getApplication()->input;
		$task = $this->getTask ();

		$model	= $this->getModel('account');
		$post	= $jinput->post->getArray();

		$post['acc_label'] 	= $jinput->get( 'acc_label', '', 'STRING');
		$post['acc_name'] 	= $jinput->get('acc_name', '', 'STRING');
		$post['acc_accesskey'] 	= $jinput->get( 'acc_accesskey', '', 'STRING');
		$post['acc_secretkey'] 	= $jinput->get('acc_secretkey', '', 'STRING');

		$model->setState( 'request', $post );
		$row = $model->store();
		if (!isset($row->id)){
			$errors[] = $row;
			return FALSE;

		}
		return $row;
	}
	
	function saveIFrame() {
		$errors = array ();
		$row = $this->save ( $errors );
		
		$redirectUrl = JRoute::_('index.php?option='.JACOMPONENT.'&view=account', false);

		if(isset($row->id)) {
			$this->redirectParent($redirectUrl, JText::_("SAVE_DATA_SUCCESSFULLY" ));
		} else {
			$this->redirectParent($redirectUrl, $errors, 'error');
		}
	}
	
	function saveConfig() {
		$jpost = JFactory::getApplication()->input->post->getArray();
		$jinput = JFactory::getApplication()->input;
		if(count($jpost)) {
			$post = $jinput->request->getArray();
			$number = $post ['number'];
			$errors = array ();
			$row = $this->save ( $errors );
	
			$backUrl = $jinput->get('backUrl', '');
			if(!empty($backUrl)) {
				$backUrl = urldecode($backUrl);
				$this->setRedirect ( $backUrl);
			} else {
				$this->setRedirect ('index.php?option='.JACOMPONENT.'&view=account');
			}
		}
	}

	function saveorder() {
		$model = $this->getModel ( 'account' );
		$msg = '';
		if (! $model->saveOrder ()) {
			JFactory::getApplication()->enqueueMessage(JText::_('ERROR_OCCURRED_DATA_NOT_SAVED' ), 'Warning');
		} else {
			$msg = JText::_('SAVE_DATA_SUCCESSFULLY' );
		}
		$this->setRedirect ( 'index.php?option='.JACOMPONENT.'&view=account', $msg );
	}

	function setDefault() {
		$jinput = JFactory::getApplication()->input;
		$model = $this->getModel ( 'account' );
		$createdate = $jinput->get('createdate',0);
		if (! $model->setDefault ( 1 )) {
			JFactory::getApplication()->enqueueMessage(JText::_('ERROR_OCCURRED_DATA_NOT_SAVED' ), 'Warning');
		} else {
			$msg = JText::_('SAVE_DATA_SUCCESSFULLY' );
		}
		$link = 'index.php?option='.JACOMPONENT.'&view=account';
		if($createdate) $link.="&createdate=".$createdate;
		$this->setRedirect ( $link, $msg );
	}

	function remove() {
		$jinput = JFactory::getApplication()->input;
		$model = $this->getModel ( 'account' );
		$cids = $jinput->get ( 'cid', null, 'ARRAY' );
		$error = array ();
		foreach ( $cids as $cid ) {
			if (! $model->delete ( $cid )) {
				$error = $cid;
			} else {
				$modelBucket = JModelLegacy::getInstance ( 'bucket', 'jaAmazonS3Model' );
				$modelBucket->deleteByAccount($cid);
			}
		}
		if (count ( $error ) > 0) {
			$err = implode ( ",", $error );
			JFactory::getApplication()->enqueueMessage(JText::_('ERROR_OCCURRED_UNABLE_TO_DELETE_THE_ITEMS_WITH_ID' ).': ' . " [$err]", 'Warning');
		} else
		$msg = JText::_("DELETE_DATA_SUCCESSFULLY" );
		$this->setRedirect ( 'index.php?option='.JACOMPONENT.'&view=account', $msg );
	}
}
?>