<?php
/**
 * ------------------------------------------------------------------------
 * JA Amazon S3 for Joomla 2.5 & Joomla 3.4
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2017 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * ------------------------------------------------------------------------
 */

// no direct access
defined ( '_JEXEC' ) or die ( 'Restricted access' );

defined('JPATH_BASE') or die();

jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.archive');
jimport('joomla.filesystem.path');

class jaAmazonS3ControllerBucket extends jaAmazonS3Controller {

	function __construct($default = array()) {

		parent::__construct ( $default );
		$jinput = JFactory::getApplication()->input;
		$this->_checkUserState();
		
		$task = $jinput->get ( 'task', '' );
		
		$model	= $this->getModel('bucket');
		$account = $model->getActiveAccount();
		
		switch ($task) {
			case 'add' :
			case 'save' :
			case 'apply' :
			case 'edit' :
				JToolBarHelper::apply ();
				JToolBarHelper::save ();
				JToolBarHelper::cancel ();
				break;
			default :
			    // Add a popup configuration button
			    if($account) {
					JToolBarHelper::addNew();
					JToolBarHelper::custom('import', 'arrow-up-2', 'arrow-up-2', JText::_("GET_LIST_BUCKETS_FROM_S3"), false);
					JToolBarHelper::deleteList(JText::_("WARNING_DO_YOU_REALLY_WANT_TO_DELETE_BUCKET_FROM_DATABASE_AND_FROM_S3_ALSO_AND_ALL_OF_ITS_CONTENTS"), 'removeS3', JText::_("DELETE_S3"));
					JToolBarHelper::deleteList(JText::_("DO_YOU_REALLY_WANT_TO_DELETE_BUCKET"));
			    }
			    JToolBarHelper::preferences(JACOMPONENT, 250, 570);
				break;
		}
		// Register Extra tasks
		$jinput->set ( 'view', 'bucket' );
		$this->registerTask ( 'add', 'edit' );
		$this->registerTask ( 'apply', 'save' );
		$this->registerTask ( 'import', 'import' );
		$this->registerTask ( 'publish', 'setDefault' );
	}
	
	function _checkUserState() {
		$model	= $this->getModel('bucket');
		$lists = $model->_getVars_admin ();
		if(!$lists['acc_id']) {
			JFactory::getApplication()->enqueueMessage(JText::_('PLEASE_SELECT_AN_ACCOUNT_FIRST' ), 'Notice');
			return false;
		}
		return true;
	}

	function display($cachable = false, $urlparams = false) {
		$jinput = JFactory::getApplication()->input;
		$user = JFactory::getUser ();
		$task =$this->getTask();
		switch ($task){
			case 'edit':
				$jinput->set ( 'layout', 'form' );
				break;
		}
		if ($user->id == 0) {

			JFactory::getApplication()->enqueueMessage(JText::_('YOU_MUST_BE_SIGNED_IN' ), 'Warning');

			$this->setRedirect ( JRoute::_ ( "index.php?option=com_user&view=login" ) );

			return;
		}

		parent::display();
	}

	function cancel() {
		$this->setRedirect ( 'index.php?option='.JACOMPONENT.'&view=bucket' );

		return TRUE;
	}
	function save(&$errors = '') {
		$jinput = JFactory::getApplication()->input;
		$task = $this->getTask ();

		$model	= $this->getModel('bucket');
		$post = JFactory::getApplication()->input->post->getArray();

		$post['bucket_name'] 	= $jinput->get( 'bucket_name', '', 'STRING');
		$post['bucket_cloudfront_domain'] 	= $jinput->get('bucket_cloudfront_domain', '', 'STRING');
		$post['bucket_acl'] 	= $jinput->get('bucket_acl', '', 'STRING');

		$bucket_region 	= $jinput->get('bucket_region', '', 'STRING');
		if (!empty($bucket_region)) {
			$region = str_replace(array('s3','.amazonaws.com'),array('',''), $bucket_region);
			if (trim($region) == '')
				$region = S3_REGION_US_E1;
			$region = ltrim($region, '-');
			$region = ltrim($region, '.');
			$post['bucket_region']=$region;
		}

		$model->setState( 'request', $post );
		$row = $model->store(true);
		if (!isset($row->id)){
			$errors = $row;
			return FALSE;

		}
		return $row;
	}
	function saveIFrame() {
		$errors = array ();
		$row = $this->save ( $errors );

		$redirectUrl = JRoute::_('index.php?option='.JACOMPONENT.'&view=bucket', false);
		if(isset($row->id)) {		

			$this->redirectParent($redirectUrl, JText::_("SAVE_DATA_SUCCESSFULLY" ));
		} else {
			$this->redirectParent($redirectUrl, $errors, 'error');
		}
	}
	
	function saveConfig() {
		$jpost = JFactory::getApplication()->input->post->getArray();
		$jinput = JFactory::getApplication()->input;
		if(count($jpost)) {
			$post = $jinput->request->getArray();
			$number = $post ['number'];
			$errors = array ();
			$row = $this->save ( $errors );
	
			$backUrl = $jinput->get('backUrl', '');
			if(!empty($backUrl)) {
				$backUrl = urldecode($backUrl);
				$this->setRedirect ( $backUrl);
			} else {
				$this->setRedirect ('index.php?option='.JACOMPONENT.'&view=bucket');
			}
		}
	}

	function saveorder() {
		$model = $this->getModel ( 'bucket' );
		$msg = '';
		if (! $model->saveOrder ()) {
			JFactory::getApplication()->enqueueMessage(JText::_('ERROR_OCCURRED_DATA_NOT_SAVED' ), 'Warning');
		} else {
			$msg = JText::_('SAVE_DATA_SUCCESSFULLY' );
		}
		$this->setRedirect ( 'index.php?option='.JACOMPONENT.'&view=bucket', $msg );
	}

	function setDefault() {
		$jinput = JFactory::getApplication()->input;
		$model = $this->getModel ( 'bucket' );
		$createdate = $jinput->get('createdate',0, 'INT');
		if (! $model->setDefault ( 1 )) {
			JFactory::getApplication()->enqueueMessage(JText::_('ERROR_OCCURRED_DATA_NOT_SAVED' ), 'Warning');
		} else {
			$msg = JText::_('SAVE_DATA_SUCCESSFULLY' );
		}
		$link = 'index.php?option='.JACOMPONENT.'&view=bucket';
		if($createdate) $link.="&createdate=".$createdate;
		$this->setRedirect ( $link, $msg );
	}

	function remove() {
		$jinput = JFactory::getApplication()->input;
		$model = $this->getModel ( 'bucket' );
		$cids = $jinput->get ( 'cid', null, 'ARRAY' );
		$error = array ();
		foreach ( $cids as $cid ) {
			if (! $model->delete ( $cid )) {
				$error = $cid;
			} else {
			}
		}
		if (count ( $error ) > 0) {
			$err = implode ( ",", $error );
			JFactory::getApplication()->enqueueMessage(JText::_('ERROR_OCCURRED_UNABLE_TO_DELETE_THE_ITEMS_WITH_ID' ).': ' . " [$err]", 'Warning');
		} else
			$msg = JText::_("DELETE_DATA_SUCCESSFULLY" );
		$this->setRedirect ( 'index.php?option='.JACOMPONENT.'&view=bucket', $msg );
	}

	function removeS3() {
		$jinput = JFactory::getApplication()->input;
		$model = $this->getModel ( 'bucket' );
		$cids = $jinput->get ( 'cid', null, 'ARRAY' );
		$error = array ();
		foreach ( $cids as $cid ) {
			if (! $model->removeS3 ( $cid )) {
				$error[] = $cid;
			} else {
			}
		}
		if (count ( $error ) > 0) {
			$err = implode ( ",", $error );
			JFactory::getApplication()->enqueueMessage(JText::_('ERROR_OCCURRED_UNABLE_TO_DELETE_THE_ITEMS_WITH_ID' ).': ' . " [$err]", 'Warning');
		} else {
			$msg = JText::_("DELETE_DATA_SUCCESSFULLY" );
			$this->setRedirect ( 'index.php?option='.JACOMPONENT.'&view=bucket', $msg );
		}
	}
	
	function import() {
		$model = $this->getModel ( 'bucket' );
		$result = $model->import();
		$msg = ($result === false) 
				? JText::_("ERROR_OCCURRED_DURING_IMPORT_BUCKET_LIST_FROM_S3") 
				: JText::_("SUCCESSFULLY_IMPORT_BUCKET_LIST_FROM_S3");
		if ($result !== false)
			$model->assignProfileAgain();
		$this->setRedirect ( 'index.php?option='.JACOMPONENT.'&view=bucket', $msg );
	}
}
?>