<?php
/**
 * ------------------------------------------------------------------------
 * JA Amazon S3 for Joomla 2.5 & Joomla 3.4
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2017 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * ------------------------------------------------------------------------
 */


// no direct access
defined ( '_JEXEC' ) or die ( 'Restricted access' );

defined('JPATH_BASE') or die();

jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.archive');
jimport('joomla.filesystem.path');

class jaAmazonS3ControllerProfile extends jaAmazonS3Controller {

	function __construct($default = array()) {

		parent::__construct ( $default );
		$jinput = JFactory::getApplication()->input;
		$this->_checkUserState();
		
		$task = $jinput->get ( 'task', '' );
		switch ($task) {
			case 'add' :
			case 'save' :
			case 'apply' :
			case 'edit' :
				JToolBarHelper::apply ();
				JToolBarHelper::save ();
				JToolBarHelper::cancel ();
				break;
			default :
			    // Add a popup configuration button
				JToolBarHelper::addNew();
				JToolBarHelper::deleteList(JText::_("DO_YOU_REALLY_WANT_TO_DELETE_PROFILE"));
			    JToolBarHelper::preferences(JACOMPONENT, 250, 570);
				break;
		}
		// Register Extra tasks
		$jinput->set ( 'view', 'profile' );
		$this->registerTask ( 'add', 'edit' );
		$this->registerTask ( 'apply', 'save' );
		$this->registerTask ( 'delete', 'remove' );
		$this->registerTask ( 'publish', 'setDefault' );
	}
	
	function _checkUserState() {
		$model	= $this->getModel('profile');
		$lists = $model->_getVars_admin ();
		return true;
	}

	function display($cachable = false, $urlparams = false) {
		$jinput = JFactory::getApplication()->input;
		$user = JFactory::getUser ();
		$task =$this->getTask();
		switch ($task){
			case 'edit':
				$jinput->set ( 'layout', 'form' );
				break;
		}
		if ($user->id == 0) {

			JFactory::getApplication()->enqueueMessage(JText::_('YOU_MUST_BE_SIGNED_IN' ), 'warning');

			$this->setRedirect ( JRoute::_ ( "index.php?option=com_user&view=login" ) );

			return;
		}

		parent::display();
	}

	function cancel() {
		$this->setRedirect ( 'index.php?option='.JACOMPONENT.'&view=profile' );

		return TRUE;
	}
	function save(&$errors = '') {
		$task = $this->getTask ();
		$jinput = JFactory::getApplication()->input;
		$model	= $this->getModel('profile');
		$post	= $jinput->post->getArray();

		$post['profile_name'] 	= $jinput->get( 'profile_name', '', 'STRING');
		$post['site_path'] 	= $jinput->get('site_path', '', 'STRING');
		$post['allowed_extension'] 	= $jinput->get('allowed_extension', '', 'STRING');
		$post['site_url'] 	= $jinput->get( 'site_url', '', 'STRING');
		$post['profile_acl'] 	= $jinput->get('profile_acl', '', 'STRING');
		$post['permission'] 	= $jinput->get('permission', ACL_PUBLIC_READ, 'STRING');
		$bucket_id = $jinput->get( 'bucket_id', 0, 'INT');
		if (empty($bucket_id))
			return false;
		else $bucket_name = $model->getBucketName($bucket_id);
		$post['bucket_name'] = $bucket_name->bucket_name;
		
		$model->setState( 'request', $post );
		$row = $model->store(true);
		if (!isset($row->id)){
			$errors = $row;
			return FALSE;

		}
		return $row;
	}
	function saveIFrame() {
		$db = JFactory::getDbo();
		$errors = array ();
		$row = $this->save ( $errors );

		$redirectUrl = JRoute::_('index.php?option='.JACOMPONENT.'&view=profile', false);
		if(isset($row->id)) {
			//check if the bucket is using for other profile
			$query = "SELECT * FROM #__jaamazons3_profile WHERE bucket_id = '{$row->bucket_id}' AND id <> '{$row->id}'";
			$db->setQuery($query);
			$rowCheck = $db->loadObject();

			if($rowCheck) {
				$this->redirectParent($redirectUrl, JText::_("SAVE_DATA_SUCCESSFULLY_BUT_BUCKET_IS_USING_FOR_OTHER_PROFILE" ));
			} else {
				$this->redirectParent($redirectUrl, JText::_("SAVE_DATA_SUCCESSFULLY" ));
			}
		} else {
			$this->redirectParent($redirectUrl, $errors, 'error');
		}
	}
	
	function saveConfig() {
		$jpost = JFactory::getApplication()->input->post->getArray();
		$jinput = JFactory::getApplication()->input;
		if(count($jpost)) {
			$post = $jinput->request->getArray();
			$number = $post ['number'];
			$errors = array ();
			$row = $this->save ( $errors );
	
			$backUrl = $jinput->get('backUrl', '', 'STRING');
			if(!empty($backUrl)) {
				$backUrl = urldecode($backUrl);
				$this->setRedirect ( $backUrl);
			} else {
				$this->setRedirect ('index.php?option='.JACOMPONENT.'&view=profile');
			}
		}
	}

	function saveorder() {
		$model = $this->getModel ( 'profile' );
		$msg = '';
		if (! $model->saveOrder ()) {
			JFactory::getApplication()->enqueueMessage(JText::_('ERROR_OCCURRED_DATA_NOT_SAVED' ), 'warning');
		} else {
			$msg = JText::_('SAVE_DATA_SUCCESSFULLY' );
		}
		$this->setRedirect ( 'index.php?option='.JACOMPONENT.'&view=profile', $msg );
	}

	function setDefault() {
		$jinput = JFactory::getApplication()->input;
		$model = $this->getModel ( 'profile' );
		$createdate = $jinput->get('createdate',0, 'INT');
		if (! $model->setDefault ( 1 )) {
			JFactory::getApplication()->enqueueMessage(JText::_('ERROR_OCCURRED_DATA_NOT_SAVED' ), 'warning');
		} else {
			$msg = JText::_('SAVE_DATA_SUCCESSFULLY' );
		}
		$link = 'index.php?option='.JACOMPONENT.'&view=profile';
		if($createdate) $link.="&createdate=".$createdate;
		$this->setRedirect ( $link, $msg );
	}

	function remove() {
		$jinput = JFactory::getApplication()->input;
		$model = $this->getModel ( 'profile' );
		$cids = $jinput->get ( 'cid', null );
		$error = array ();
		foreach ( $cids as $cid ) {
			if (! $model->delete ( $cid )) {
				$error = $cid;
			} else {
			}
		}
		if (count ( $error ) > 0) {
			$err = implode ( ",", $error );
			JFactory::getApplication()->enqueueMessage(JText::_('ERROR_OCCURRED_UNABLE_TO_DELETE_THE_ITEMS_WITH_ID' ).': ' . " [$err]", 'warning');
		} else
		$msg = JText::_("DELETE_DATA_SUCCESSFULLY" );
		$this->setRedirect ( 'index.php?option='.JACOMPONENT.'&view=profile', $msg );
	}
	
	function import() {
		$model = $this->getModel ( 'profile' );
		$result = $model->import();
		$msg = ($result === false) 
				? JText::_("ERROR_OCCURRED_DURING_IMPORT_PROFILE_LIST_FROM_S3") 
				: JText::_("SUCCESSFULLY_IMPORT_PROFILE_LIST_FROM_S3");
		$this->setRedirect ( 'index.php?option='.JACOMPONENT.'&view=profile', $msg );
	}
}
?>