<?php
/**
 * ------------------------------------------------------------------------
 * JA Amazon S3 for Joomla 2.5 & Joomla 3.4
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2017 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * ------------------------------------------------------------------------
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.controller' );

jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.archive');
jimport('joomla.filesystem.path');

/**
 * Media Manager Component Controller
 *
 * @package		Joomla
 * @subpackage	Media
 * @version 1.5
 */
class jaAmazonS3ControllerRepo extends JControllerLegacy
{
	function __construct($default = array()) {

		parent::__construct ( $default );
		$jinput = JFactory::getApplication()->input;
		$jinput->set ( 'view', 'repo' );
		$this->registerTask ( 'update_list_s3_files', 'updateListS3Files' );
	}
	/**
	 * Display the view
	 */
	function display($cachable = false, $urlparams = false)
	{
		$mainframe = JFactory::getApplication('administrator');
		$jinput = JFactory::getApplication()->input;
		$vName = $jinput->get('view', 'media');
		
		$this->_checkUserState();
		switch ($vName)
		{
			case 'images':
				$vLayout = $jinput->get( 'layout', 'default' );
				$mName = 'manager';

				break;

			case 'imagesList':
				$mName = 'list';
				$vLayout = $jinput->get( 'layout', 'default' );

				break;

			case 'repolist':
				$mName = 'repolist';
				//$vLayout = $mainframe->getUserStateFromRequest('media.list.layout', 'layout', 'details', 'word');
				$vLayout = "details";

				break;

			case 'media':
			default:
				$vName = 'repo';
				$vLayout = $jinput->get( 'layout', 'default' );
				$mName = 'repo';
				break;
		}

		$document = JFactory::getDocument();
		$vType	= $document->getType();

		// Get/Create the view
		$view = $this->getView( $vName, $vType);

		// Get/Create the model
		if ($model = $this->getModel($mName)) {
			// Push the model into the view (as default)
			$view->setModel($model, true);
		}

		// Set the layout
		$view->setLayout($vLayout);

		// Display the view
		$view->display();
	}

	function ftpValidate()
	{
		// Set FTP credentials, if given
		jimport('joomla.client.helper');
		JClientHelper::setCredentialsFromRequest('ftp');
	}
	
	function _checkUserState() {
		$model	= $this->getModel('repo');
		$lists = $model->_getVars_admin ();
		if(!$lists['bucket_id']) {
			JFactory::getApplication()->enqueueMessage(JText::_("PLEASE_SELECT_A_BUCKET_FIRST"), 'notice');
			return false;
		}
		return true;
	}
	
	function delete_advance() {
		$mainframe = JFactory::getApplication('administrator');
		$jinput = JFactory::getApplication()->input;
		
		$model	= $this->getModel('repo');
		$bucket = $model->getActiveBucket();
		
		$pcre = $jinput->get('pcre', '\.php$');
		$folder = $jinput->get('upload_folder', '');
		
		if($bucket !== false && !empty($pcre)) {
			$result = $model->deleteAdvance($bucket, $folder, $pcre);
		} else {
			$mainframe->redirect("index.php?option=".JACOMPONENT."&view=repo", JText::_("PLEASE_SELECT_A_BUCKET_FIRST"), 'error');
		}
		$jinput->set('folder', $folder);

		if($result){
			JFactory::getApplication()->enqueueMessage(JText::_("SUCCESSFULLY_DELETE_FILE"), 'notice');
		}else{
			JFactory::getApplication()->enqueueMessage(JText::sprintf("NOT_FIND_SUCCESSFULLY_DELETE_FILE",$pcre), 'notice');
		}
		$this->display();
	}
	
	function create_folder() {
		$mainframe = JFactory::getApplication('administrator');
		$jinput = JFactory::getApplication()->input;
		
		$model	= $this->getModel('repo');
		$bucket = $model->getActiveBucket();
		
		$modelAccount = JModelLegacy::getInstance ( 'bucket', 'jaAmazonS3Model' );
		$account = $modelAccount->getActiveAccount();
		
		$replace = $jinput->get('replace_file', 0);
		$folder = $jinput->get('upload_folder', '', 'STRING');
		$new_folder = $jinput->get('new_folder', '', 'STRING');
		
		$folder = jaStorageHelper::cleanPath($folder);
		$current = $folder;
		if(!empty($current)) {
			$current .= "/";
		}
		
		if(!empty($new_folder)) {
			if($bucket !== false) {
				$s3 = jaStorageHelper::getStorage_V2($account, $bucket->bucket_region);
				$checkPath = $current.$new_folder.'/';
				//check if folder is already exists
				//$result = $s3->list_objects($bucket->bucket_name, array("prefix" => $current, "delimiter" => "/", "max-keys" => 5000));
				$existed = 0;
				$result = $s3->getPaginator('ListObjects', [
				    'Bucket' => $bucket->bucket_name,
				    'Prefix' => $checkPath,
				    'MaxKeys' => 2,
				]);
				
				foreach ($result->search('[Contents[]][]') as $object) {
				    if (isset($object['Key'])) {
				    	$existed=1;
				    	break;
				    }
				}
				$folders = array();
				if($existed) {
					//J_Error::raiseNotice(200, JText::_("CAN_NOT_CREATE_A_FOLDER_WHEN_THAT_FOLDER_ALREADY_EXISTS"));
					$mainframe->redirect("index.php?option=".JACOMPONENT."&view=repo", JText::_("CAN_NOT_CREATE_A_FOLDER_WHEN_THAT_FOLDER_ALREADY_EXISTS"), 'error');
				} else {
					$filename = $checkPath . '/index.html';
					$filename = jaStorageHelper::cleanPath($filename);
					
					
					$secureFile = dirname(__FILE__).'/index.html';
					$content = file_get_contents($secureFile);
					
					// Upload an object to Amazon S3
					$opts = array(
					    'Bucket' => $bucket->bucket_name,
					    'Key'    => $filename,
					    'Body'   => $content,
					    'ACL' => ACL_PUBLIC_READ,
					);
					
					// Upload an object to Amazon S3
					$result = $s3->putObject($opts);
					
					// We can poll the object until it is accessible
					$s3->waitUntil('ObjectExists', array(
					    'Bucket' => $bucket->bucket_name,
					    'Key'    => $filename
					));
					
					if($result === false || empty($result)) {
						//J_Error::raiseWarning(100, JText::_("ERROR_OCCURRED_UNABLE_TO_CREATE_FOLDER"));
						$mainframe->redirect("index.php?option=".JACOMPONENT."&view=repo", JText::_("ERROR_OCCURRED_UNABLE_TO_CREATE_FOLDER"), 'error');
					} else {
						//J_Error::raiseNotice(200, JText::_("SUCCESSFULLY_CREATE_FOLDER"));
						$mainframe->redirect("index.php?option=".JACOMPONENT."&view=repo", JText::_("SUCCESSFULLY_CREATE_FOLDER"));
					}
				}
			} else {
				//J_Error::raiseWarning(100, JText::_("PLEASE_SELECT_A_BUCKET_FIRST"));
				$mainframe->redirect("index.php?option=".JACOMPONENT."&view=repo", JText::_("PLEASE_SELECT_A_BUCKET_FIRST"), 'error');
			}
		}
		
		$jinput->set('folder', $folder);
		//die('test');
		$this->display();
	}
	
	function updateListS3Files() {
		$jinput = JFactory::getApplication()->input;
		$folder = $jinput->get('upload_folder', '', 'STRING');
		$folder = jaStorageHelper::cleanPath($folder);
		$bucket_id = $jinput->get('bid', 0);
		
		$model	= $this->getModel('repo');
		$bucket = $model->getActiveBucket($bucket_id);
		
		
		//$folder = '';//get all files of bucket
		
		if($bucket !== false) {
			$db = JFactory::getDBO();
			$serverFiles = $model->getListServerFiles($bucket, $folder);
			/**
			 * CLEAN LOG:
			 * since some s3 files can be deleted by other s3 client (Eg: s3fox, ...) or by some reason.
			 * So, We must clear log database and get list s3 files again 
			 * to correct replacement of s3 plugin
			 */
			$sqlClean = "UPDATE `#__jaamazons3_file` SET `file_exists` = 0 WHERE bucket_id = {$db->quote($bucket->id)} AND file_checksum <> ''";
			if(!empty($folder)) {
				$updatePath = $folder . '/';
				$sqlClean .= "  AND INSTR(`path`, {$db->quote($updatePath)}) = 1";
			}
			$db->setQuery($sqlClean);
			$db->query();
			
			//
			$sqlLog = array();
			if(is_array($serverFiles) && count($serverFiles)) {
				foreach ($serverFiles as $sfile) {
					$filename = $sfile->Key;
					$uploadTimeLog = date('Y-m-d H:i:s', strtotime($sfile->LastModified));
					$checksum = str_replace('"', '', $sfile->ETag);
                    $strSQL = "INSERT INTO `#__jaamazons3_file` SET bucket_id = {$db->quote($bucket->id)}, ";
                    $strSQL .= "path = {$db->quote($filename)}, last_update = {$db->quote($uploadTimeLog)}, ";
                    $strSQL .= "file_checksum = {$db->quote($checksum)}, `file_exists` = 1 ";
                    $strSQL .= "ON DUPLICATE KEY UPDATE last_update = {$db->quote($uploadTimeLog)}, ";
                    $strSQL .= "file_checksum = {$db->quote($checksum)}, `file_exists` = 1;" . "\r\n";
					$sqlLog[] = $strSQL;
				}
			}
				
			if(count($sqlLog)) {
				foreach ($sqlLog as $sql) {
					$db->setQuery($sql);
					$db->query();
				}
			}
			//log update time
            $now =  date('Y-m-d H:i:s');
			$sqlSyncLog = "UPDATE `#__jaamazons3_bucket` SET `last_sync` = " . $db->quote($now) . " WHERE id = {$db->quote($bucket->id)}";
			$db->setQuery($sqlSyncLog);
			$db->query();
			//
			echo JText::_("SUCCESSFULLY_UPDATE_LIST_FILES_ON_S3_TO_DATABASE");
		} else {
			echo JText::_("INVALID_BUCKET");
		}
		exit();
	}
}
