<?php
/**
 * ------------------------------------------------------------------------
 * JA Amazon S3 for Joomla 2.5 & Joomla 3.4
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2017 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * ------------------------------------------------------------------------
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

/**
 * This class is used for auto update reference data feature of the component
 *
 * @package Joomla
 * 
 * Useful functions for update database
 */
class jaAutoUpdate
{
	/**
     * Check to run auto update again
     *
     * @return void
     */
	public static function checkRunUpdate()
	{
		jimport('joomla.filesystem.file');
		$scriptPath = jaAutoUpdate::getDatabasePath();

		/**
         * Example code for upgrade to version x.x.x
         */
		$versions = array("2.5.7");
		foreach($versions as $version) {
			$check = dirname(__FILE__)."/updated_{$version}.log";
			if (!JFile::exists($check)) {
				//processing code here
				$file = $scriptPath.'upgrade_v'.$version.'.sql';
				jaAutoUpdate::parseSQLFile($file);
				//end of update code

				$flag = 'Updated at '.date('Y-m-d H:i:s');
				JFile::write($check, $flag);
			}
		}
	}

	public static function getDatabasePath() {
		return JPATH_ADMINISTRATOR.'/components/com_jaamazons3/installer/sql/';
	}

	public static function parseSQLFile($file) {
		jimport('joomla.filesystem.file');

		if(JFile::exists($file)) {
			$buffer = JFile::read($file);
			if($buffer) {
				$db = JFactory::getDbo();
				$queries = $db->splitSql($buffer);
				foreach ($queries as $query) {
					$db->setQuery($query);
					$db->query();
				}
			}
		}
	}
}